# GraphsMatching

[![Build status](https://github.com/JuliaGraphs/GraphsMatching.jl/actions/workflows/ci.yml/badge.svg?branch=master)](https://github.com/JuliaGraphs/GraphsMatching.jl/actions/workflows/ci.yml?query=branch%3Amaster)
[![Code coverage](http://codecov.io/github/JuliaGraphs/GraphsMatching.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaGraphs/GraphsMatching.jl?branch=master)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

Matching algorithms on top of [Graphs.jl](https://github.com/JuliaGraphs/Graphs.jl).

## Usage

The results of any matching is returned as a `MatchingResult` struct
containing the `mate` and `weight` fields.

### Perfect matching

```julia
g = complete_graph(4)
w = Dict{Edge,Float64}()
w[Edge(1,3)] = 10
w[Edge(1,4)] = 0.5
w[Edge(2,3)] = 11
w[Edge(2,4)] = 2
w[Edge(1,2)] = 100

# find the perfect matching of minimum weight
match = minimum_weight_perfect_matching(g, w, 50)
# match.mate[1] == 4
# match.mate[4] == 1
# match.mate[2] == 3
# match.mate[3] == 2
# match.weight ≈ 11.5
```

### Maximum weight matching

A maximum weight matching is solved as a Linear Programming
problem and requires an LP optimizer for bipartite graphs and a MILP solver for general graphs respecting the [MathOptInterface](https://github.com/JuliaOpt/MathOptInterface.jl) optimizer interface. A list of solvers can be found in the [JuMP documentation](http://www.juliaopt.org/JuMP.jl/v0.19.0/installation/#Getting-Solvers-1).

```julia
using JuMP, Cbc #import a MILP solver
g = complete_graph(3)
w = zeros(3,3)
w[1,2] = 1
w[3,2] = 1
w[1,3] = 1
match = maximum_weight_matching(g, optimizer_with_attributes(Cbc.Optimizer, "LogLevel" => 0),w)
# match.weight ≈ 1
```

function maximum_weight_maximal_matching_hungarian(g::Graph,
          w::AbstractMatrix{T}=default_weights(g)) where {T <: Real}
  edge_list = collect(edges(g))
  n = nv(g)

  # Determine the bipartition of the graph. 
  bipartition = bipartite_map(g)
  if length(bipartition) != n # Equivalent to !is_bipartite(g), but reuses the results of the previous function call.
    error("The Hungarian algorithm only works for bipartite graphs; otherwise, prefer the Blossom algorithm (not yet available in GraphsMatching")
  end
  n_first = count(bipartition .== 1)
  n_second = count(bipartition .== 2)

  to_bipartition_1 = [count(bipartition[1:i] .== 1) for i in 1:n]
  to_bipartition_2 = [count(bipartition[1:i] .== 2) for i in 1:n]

  # hungarian() minimises the total cost, while this function is supposed to maximise the total weights.
  wDual = maximum(w) .- w

  # Remove weights that are not in the graph (Hungarian.jl considers all weights that are not missing values as real edges).
  # Assume w is symmetric, so that the weight of matching i->j is the same as the one for j->i. 
  weights = Matrix{Union{Missing, T}}(missing, n_first, n_second)

  for i in 1:n
    for j in 1:n
      if Edge(i, j) ∈ edge_list || Edge(j, i) ∈ edge_list 
        if bipartition[i] == 1 # and bipartition[j] == 2
          idx_first = to_bipartition_1[i]
          idx_second = to_bipartition_2[j]
        else # bipartition[i] == 2 and bipartition[j] == 1
          idx_first = to_bipartition_1[j]
          idx_second = to_bipartition_2[i]
        end

        weight_to_add = (Edge(i, j) ∈ edge_list) ? wDual[i, j] : wDual[j, i]

        weights[idx_first, idx_second] = weight_to_add
      end
    end
  end

  # Run the Hungarian algorithm.
  assignment, _ = hungarian(weights)

  # Convert the output format to match LGMatching's. 
  pairs = Tuple{Int, Int}[]
  mate = fill(-1, n) # Initialise to unmatched. 
  for i in eachindex(assignment)
    if assignment[i] != 0 # If matched: 
      original_i = findfirst(to_bipartition_1 .== i)
      original_j = findfirst(to_bipartition_2 .== assignment[i])

      mate[original_i] = original_j
      mate[original_j] = original_i

      push!(pairs, (original_i, original_j))
    end
  end

  # Compute the cost for this matching (as weights had to be changed for Hungarian.jl, the one returned by hungarian() makes no sense). 
  cost = sum(w[p[1], p[2]] for p in pairs)

  # Return the result.
  return MatchingResult(cost, mate)
end

"""
maximum_weight_matching(g::Graph, w::Dict{Edge,Real} -> Dict{Edge,Int64}

Given a graph `g` and an edgemap `w` containing weights associated to edges,
returns a matching with the maximum total weight.
`w` is a dictionary that maps edges i => j to weights.
If no weight parameter is given, all edges will be considered to have weight 1
(results in max cardinality matching)

The efficiency of the algorithm depends on the input graph:
  - If the graph is bipartite, then the LP relaxation is integral.
  - If the graph is not bipartite, then it requires a MIP solver and
  the computation time may grow exponentially.

The package JuMP.jl and one of its supported solvers is required.

Returns MatchingResult containing:
  - a solve status (indicating whether the problem was solved to optimality)
  - the optimal cost
  - a list of each vertex's match (or -1 for unmatched vertices)
"""
function maximum_weight_matching end

function maximum_weight_matching(
    g::Graph,
    optimizer,
    w::AbstractMatrix{U} = default_weights(g),
) where {U<:Real}

    model = Model(optimizer)
    n = nv(g)
    edge_list = collect(edges(g))

    # put the edge weights in w in the right order to be compatible with edge_list
    for j = 1:n
        for i = 1:n
            if i > j && w[i, j] > zero(U) && w[j, i] < w[i, j]
                w[j, i] = w[i, j]
            end
            if Edge(i, j) ∉ edge_list
                w[i, j] = zero(U)
            end
        end
    end

    if is_bipartite(g)
        @variable(model, x[edge_list] >= 0) # no need to enforce integrality
    else
        @variable(model, x[edge_list] >= 0, Int) # requires MIP solver
    end
    @objective(model, Max, sum(x[e] * w[src(e), dst(e)] for e in edge_list))

    @constraint(
        model,
        c1[i = 1:n],
        sum(x[Edge(minmax(i, j))] for j in neighbors(g, i)) <= 1
    )
    optimize!(model)
    status = JuMP.termination_status(model)
    status != MOI.OPTIMAL && error("JuMP solver failed to find optimal solution.")
    solution = value.(x)
    cost = objective_value(model)
    return MatchingResult(cost, dict_to_arr(n, solution, edge_list))
end

""" Returns an array of mates from a dictionary that maps edges to {0,1} """
function dict_to_arr(
    n::Int64,
    solution::JuMP.Containers.DenseAxisArray{U,1,Tuple{Array{E,1}}},
    edge_list::AbstractVector{E},
) where {U<:Real,E<:Edge}
    mate = fill(-1, n)
    for e in edge_list
        if solution[e] >= 1 - 1e-5 # Some tolerance to numerical approximations by the solver.
            mate[src(e)] = dst(e)
            mate[dst(e)] = src(e)
        end
    end
    return mate
end


function default_weights(g::G) where {G<:AbstractGraph}
    m = spzeros(nv(g), nv(g))
    for e in edges(g)
        m[src(e), dst(e)] = 1
    end
    return m
end

"""
maximum_weight_matching_reduction(g::Graph, w::Matrix{Real}) -> Array{Edge}

Given a graph `g` and an edgemap `w` containing weights associated to edges,
returns a matching with the maximum total weight.
`w` is an adjacent matrix that maps edges i => j to weights.
If no weight parameter is given, all edges will be considered to have weight 1

This algorithm uses a reduction based on the minimum_weight_perfect_matching function 
to find the maximum weight matching (see https://homepages.cwi.nl/~schaefer/ftp/pdf/masters-thesis.pdf section 1.5.1).

Return an array of edges contained in the matching.
"""
function maximum_weight_matching_reduction(
    g::Graph,
    w::AbstractMatrix{U} = default_weights(g),
) where {U<:Real}

    h = deepcopy(g)
    # collect needed since we modify the edges later
    edge_iter = collect(edges(h))
    l = nv(h)
    add_vertices!(h, l)
    weights = Dict{edgetype(g), eltype(w)}()
    for edge in edge_iter
        add_edge!(h, src(edge) + l, dst(edge) + l)
        weights[edge] = -w[src(edge), dst(edge)]
        weights[Edge(dst(edge), src(edge))] = -w[src(edge), dst(edge)]
        weights[Edge(src(edge) + l, dst(edge) + l)] = -w[src(edge), dst(edge)]
        weights[Edge(dst(edge) + l, src(edge) + l)] = -w[src(edge), dst(edge)]
    end
    for i = 1:l
        add_edge!(g, i, i + l)
        weights[Edge(i, i + l)] = 0
    end

    match = minimum_weight_perfect_matching(h, weights)

    result = [Edge(i, match.mate[i]) for i in 1:l if match.mate[i] <= l && match.mate[i] > 0]

    return result
end

module GraphsMatching

using Graphs

using SparseArrays: spzeros

using JuMP
using MathOptInterface
const MOI = MathOptInterface
import LEMONGraphs
using Hungarian

export MatchingResult,
    maximum_weight_matching,
    maximum_weight_matching_reduction,
    maximum_weight_maximal_matching,
    minimum_weight_perfect_matching,
    HungarianAlgorithm,
    LPAlgorithm,
    BlossomVAlgorithm,
    LEMONMWPMAlgorithm

function __init__()
    if isdefined(Base.Experimental, :register_error_hint)
        Base.Experimental.register_error_hint(MethodError) do io, exc, argtypes, kwargs
            if BlossomVAlgorithm in argtypes
                print(io,"""\nPlease first import `BlossomV` to make BlossomV-based matching available.""")
            end
        end
    end
end

"""
    struct MatchingResult{U}
        weight::U
        mate::Vector{Int}
    end

A type representing the result of a matching algorithm.

    weight: total weight of the matching

    mate:    `mate[i] = j` if vertex `i` is matched to vertex `j`.
             `mate[i] = -1` for unmatched vertices.
"""
struct MatchingResult{U<:Real}
    weight::U
    mate::Vector{Int}
end

include("lp.jl")
include("maximum_weight_matching.jl")
include("minimum_weight_perfect_matching.jl")
include("hungarian.jl")
include("maximum_weight_maximal_matching.jl")

end # module

"""
    AbstractMaximumWeightMaximalMatchingAlgorithm
Abstract type that allows users to pass in their preferred algorithm
"""
abstract type AbstractMaximumWeightMaximalMatchingAlgorithm end

"""
    LPAlgorithm <: AbstractMaximumWeightMaximalMatchingAlgorithm
Forces the maximum_weight_maximal_matching function to use a linear programming formulation.
"""
struct LPAlgorithm <: AbstractMaximumWeightMaximalMatchingAlgorithm end

function maximum_weight_maximal_matching(
    g::Graph,
    w::AbstractMatrix{T},
    algorithm::LPAlgorithm,
    optimizer = nothing
) where {T<:Real}

    return maximum_weight_maximal_matching_lp(g, optimizer, w)
end

"""
    HungarianAlgorithm <: AbstractMaximumWeightMaximalMatchingAlgorithm
Forces the maximum_weight_maximal_matching function to use the Hungarian algorithm.
"""
struct HungarianAlgorithm <: AbstractMaximumWeightMaximalMatchingAlgorithm end

function maximum_weight_maximal_matching(
    g::Graph,
    w::AbstractMatrix{T},
    algorithm::HungarianAlgorithm,
    optimizer = nothing
) where {T<:Real}
    return maximum_weight_maximal_matching_hungarian(g, w)
end

"""
    maximum_weight_maximal_matching{T<:Real}(g, w::Dict{Edge,T})

Given a bipartite graph `g` and an edge map `w` containing weights associated to edges,
returns a matching with the maximum total weight among the ones containing the
greatest number of edges.

Edges in `g` not present in `w` will not be considered for the matching.

A `cutoff` keyword argument can be given, to reduce computational times
excluding edges with weights lower than the cutoff.

Finally, a specific algorithm can be chosen (`algorithm` keyword argument);
each algorithm has specific dependencies. For instance:

- If `algorithm=HungarianAlgorithm()` (the default), the package Hungarian.jl is used.
  This algorithm is always polynomial in time, with complexity O(n³).
- If `algorithm=LPAlgorithm()`, the package JuMP.jl and one of its supported solvers is required.
  In this case, the algorithm relies on a linear relaxation on of the matching problem, which is
  guaranteed to have integer solution on bipartite graphs. A solver must be provided with
  the `optimizer` keyword parameter.

The returned object is of type `MatchingResult`.
"""
function maximum_weight_maximal_matching(
        g::Graph,
        w::AbstractMatrix{T};
        cutoff = nothing,
        algorithm::AbstractMaximumWeightMaximalMatchingAlgorithm = HungarianAlgorithm(),
        optimizer = nothing
    ) where {T<:Real}

    if cutoff != nothing && ! isa(cutoff, Real)
        error("The cutoff value must be of type Real or nothing.")
    end

    if cutoff != nothing
        return maximum_weight_maximal_matching(g, cutoff_weights(w, cutoff), algorithm, optimizer)
    else
        return maximum_weight_maximal_matching(g, w, algorithm, optimizer)
    end
end

"""
    cutoff_weights copies the weight matrix with all elements below cutoff set to 0
"""
function cutoff_weights(w::AbstractMatrix{T}, cutoff::R) where {T<:Real, R<:Real}
    wnew = copy(w)
    for j in 1:size(w,2)
        for i in 1:size(w,1)
            if wnew[i,j] < cutoff
                wnew[i,j] = zero(T)
            end
        end
    end
    wnew
end

@deprecate maximum_weight_maximal_matching(g::Graph, optimizer, w::AbstractMatrix{T}, cutoff::R) where {T<:Real, R<:Real} maximum_weight_maximal_matching(g, w, algorithm=LPAlgorithm(), cutoff=cutoff, optimizer=optimizer)

module GraphsMatchingBlossomVExt

using Graphs
using GraphsMatching
import BlossomV

function GraphsMatching.minimum_weight_perfect_matching(g::Graph, w::Dict{E,U}, ::BlossomVAlgorithm) where {U<:Integer,E<:Edge}
    m = BlossomV.Matching(nv(g))
    for (e, c) in w
        BlossomV.add_edge(m, src(e) - 1, dst(e) - 1, c)
    end
    BlossomV.solve(m)

    mate = fill(-1, nv(g))
    totweight = zero(U)
    for i in 1:nv(g)
        j = BlossomV.get_match(m, i - 1) + 1
        mate[i] = j <= 0 ? -1 : j
        if i < j
            totweight += w[Edge(i, j)]
        end
    end
    return MatchingResult(totweight, mate)
end

end

"""
    minimum_weight_perfect_matching(g, w::Dict{Edge,Real}; tmaxscale)
    minimum_weight_perfect_matching(g, w::Dict{Edge,Real}, cutoff; tmaxscale)
    minimum_weight_perfect_matching(g, w::Dict{Edge,Real}, algorithm::AbstractMinimumWeightPerfectMatchingAlgorithm; tmaxscale)
    minimum_weight_perfect_matching(g, w::Dict{Edge,Real}, cutoff, algorithm::AbstractMinimumWeightPerfectMatchingAlgorithm; tmaxscale)

Given a graph `g` and an edgemap `w` containing weights associated to edges,
returns a matching with the mimimum total weight among the ones containing
exactly `nv(g)/2` edges.

Edges in `g` not present in `w` will not be considered for the matching.

You can use the `algorithm` argument to specify the algorithm to use.

A `cutoff` argument can be given, to reduce the computational time by
excluding edges with weights higher than the cutoff (effective only for some algorithms,
not for the default `LEMONMWPMAlgorithm`).

When the weights are non-integer types, the keyword argument `tmaxscale` can be used to
scale the weights to integer values.
In case of error try to change `tmaxscale` (default is `tmaxscale=10`).
The scaling is as follows:
```
tmax = typemax(Int32) / tmaxscale
weight = round(Int32, (weight-minimum_weight) / max(maximum_weight-minimum_weight, 1) * tmax)
```

The returned object is of type [`MatchingResult`](@ref).

See also: [`BlossomVAlgorithm`](@ref)
"""
function minimum_weight_perfect_matching end

"""
    AbstractMinimumWeightPerfectMatchingAlgorithm

Abstract type that allows users to pass in their preferred algorithm

See also: [`minimum_weight_perfect_matching`](@ref), [`BlossomVAlgorithm`](@ref)
"""
abstract type AbstractMinimumWeightPerfectMatchingAlgorithm end

"""
    BlossomVAlgorithm()

Use the BlossomV algorithm to find the minimum weight perfect matching.
Depends on the BlossomV.jl package. You have to call `using BlossomV`
before using this algorithm.

This algorithm dispatches to the BlossomV library, a C library for finding
minimum weight perfect matchings in general graphs.
The BlossomV library is not open source, and thus we can not distribute a
a precompiled binary with GraphsMatching.jl. We attempt to build it on
installation, but unlike typical Julia packages, the build process is prone
to failure if you do not have all the dependencies installed.
If BlossomV.jl does not work on your system,
consider using the LEMONGraphs.jl algorithm instead (the default algorithm),
which we distribute precompiled on all platforms.

See also: [`minimum_weight_perfect_matching`](@ref), [`LEMONMWPMAlgorithm`](@ref)
"""
struct BlossomVAlgorithm <: AbstractMinimumWeightPerfectMatchingAlgorithm end

"""
    LEMONMWPMAlgorithm()

Use the LEMON C++ implementation of minimum weight perfect matching.

See also: [`minimum_weight_perfect_matching`](@ref), [`BlossomVAlgorithm`](@ref)
"""
struct LEMONMWPMAlgorithm <: AbstractMinimumWeightPerfectMatchingAlgorithm end

function minimum_weight_perfect_matching(
    g::Graph, w::Dict{E,U}
) where {U<:Integer,E<:Edge}
    return minimum_weight_perfect_matching(g, w, LEMONMWPMAlgorithm())
end

function minimum_weight_perfect_matching(
    g::Graph, w::Dict{E,U}, cutoff::Real, algorithm::AbstractMinimumWeightPerfectMatchingAlgorithm=LEMONMWPMAlgorithm(); kws...
) where {U<:Real,E<:Edge}
    wnew = Dict{E,U}()
    for (e, c) in w
        if c <= cutoff
            wnew[e] = c
        end
    end
    return minimum_weight_perfect_matching(g, wnew, algorithm; kws...)
end

function minimum_weight_perfect_matching(
    g::Graph, w::Dict{E,U}, algorithm::AbstractMinimumWeightPerfectMatchingAlgorithm=LEMONMWPMAlgorithm(); tmaxscale=10.0
) where {U<:AbstractFloat,E<:Edge}
    wnew = Dict{E,Int32}()
    cmax = maximum(values(w))
    cmin = minimum(values(w))

    tmax = typemax(Int32) / tmaxscale # /10 is kinda arbitrary,
    # hopefully high enough to not occur in overflow problems
    for (e, c) in w
        wnew[e] = round(Int32, (c - cmin) / max(cmax - cmin, 1) * tmax)
    end
    match = minimum_weight_perfect_matching(g, wnew, algorithm)
    weight = zero(U)
    for i in 1:nv(g)
        j = match.mate[i]
        if j > i
            weight += get(w, E(i, j), zero(U))
        end
    end
    return MatchingResult(weight, match.mate)
end

function minimum_weight_perfect_matching(g::Graph, w::Dict{E,U}, ::LEMONMWPMAlgorithm) where {U<:Integer,E<:Edge}
    max = 2*abs(maximum(values(w)))
    weights = [-get(w, e, max) for e in edges(g)]
    totweight, mate = LEMONGraphs.maxweightedperfectmatching(g, weights)
    return MatchingResult(-totweight, mate)
end

using Graphs
using GraphsMatching
using Test
using HiGHS
using JuMP
using LinearAlgebra: I

if !Sys.iswindows() && Sys.ARCH == :x86_64
    using Pkg
    Pkg.add("BlossomV")
    import BlossomV # to test the extension
end

@testset "GraphsMatching" begin

    @testset "maximum_weight_matching_reduction" begin
        N = Int(1e2)
        g = complete_graph(N)
        for i = 1:10
            w = randn(N, N)
            w = transpose(w) * w
            match_sol = maximum_weight_matching(
                g,
                HiGHS.Optimizer,
                w,
            )
            match_red = maximum_weight_matching_reduction(g, w)
            sol = Edge[]
            for i = 1:N
                if (match_sol.mate[i] > 0)
                    push!(sol, Edge(i, match_sol.mate[i]))
                end
            end
            @test sol == match_red
        end
    end

    @testset "maximum_weight_matching" begin
        g = complete_graph(3)
        w = [
            1 2 1
            1 1 1
            3 1 1
        ]
        match = maximum_weight_matching(
            g,
            HiGHS.Optimizer,
            w,
        )
        @test match.mate[1] == 3
        @test match.weight ≈ 3

        g = complete_graph(3)
        w = zeros(3, 3)
        w[1, 2] = 1
        w[3, 2] = 1
        w[1, 3] = 1
        match = maximum_weight_matching(
            g,
            HiGHS.Optimizer,
            w,
        )
        @test match.weight ≈ 1


        g = Graph(4)
        add_edge!(g, 1, 3)
        add_edge!(g, 1, 4)
        add_edge!(g, 2, 4)

        w = zeros(4, 4)
        w[1, 3] = 1
        w[1, 4] = 3
        w[2, 4] = 1

        match = maximum_weight_matching(
            g,
            HiGHS.Optimizer,
            w,
        )
        @test match.weight ≈ 3
        @test match.mate[1] == 4
        @test match.mate[2] == -1
        @test match.mate[3] == -1
        @test match.mate[4] == 1

        g = Graph(4)
        add_edge!(g, 1, 2)
        add_edge!(g, 2, 3)
        add_edge!(g, 3, 1)
        add_edge!(g, 3, 4)
        match = maximum_weight_matching(
            g,
            HiGHS.Optimizer,
        )
        @test match.weight ≈ 2
        @test match.mate[1] == 2
        @test match.mate[2] == 1
        @test match.mate[3] == 4
        @test match.mate[4] == 3

        w = zeros(4, 4)
        w[1, 2] = 1
        w[2, 3] = 1
        w[1, 3] = 1
        w[3, 4] = 1

        match = maximum_weight_matching(
            g,
            HiGHS.Optimizer,
            w,
        )
        @test match.weight ≈ 2
        @test match.mate[1] == 2
        @test match.mate[2] == 1
        @test match.mate[3] == 4
        @test match.mate[4] == 3

        w = zeros(4, 4)
        w[1, 2] = 1
        w[2, 3] = 1
        w[1, 3] = 5
        w[3, 4] = 1

        match = maximum_weight_matching(
            g,
            HiGHS.Optimizer,
            w,
        )
        @test match.weight ≈ 5
        @test match.mate[1] == 3
        @test match.mate[2] == -1
        @test match.mate[3] == 1
        @test match.mate[4] == -1
    end


    @testset "maximum_weight_maximal_matching" begin

        g = complete_bipartite_graph(2, 2)
        w = zeros(4, 4)
        w[1, 3] = 10.0
        w[1, 4] = 1.0
        w[2, 3] = 2.0
        w[2, 4] = 11.0
        match = maximum_weight_maximal_matching(
            g,
            w,
            algorithm = LPAlgorithm(),
            optimizer = HiGHS.Optimizer,
        )
        @test match.weight ≈ 21
        @test match.mate[1] == 3
        @test match.mate[3] == 1
        @test match.mate[2] == 4
        @test match.mate[4] == 2

        g = complete_bipartite_graph(2, 4)
        w = zeros(6, 6)
        w[1, 3] = 10
        w[1, 4] = 0.5
        w[2, 3] = 11
        w[2, 4] = 1
        match = maximum_weight_maximal_matching(
            g,
            w,
            algorithm = LPAlgorithm(),
            optimizer = HiGHS.Optimizer,
        )
        @test match.weight ≈ 11.5
        @test match.mate[1] == 4
        @test match.mate[4] == 1
        @test match.mate[2] == 3
        @test match.mate[3] == 2

        g = complete_bipartite_graph(2, 6)
        w = zeros(8, 8)
        w[1, 3] = 10
        w[1, 4] = 0.5
        w[2, 3] = 11
        w[2, 4] = 1
        w[2, 5] = -1
        w[2, 6] = -1
        match = maximum_weight_maximal_matching(
            g,
            w,
            algorithm = LPAlgorithm(),
            optimizer = HiGHS.Optimizer,
            cutoff = 0,
        )
        @test match.weight ≈ 11.5
        @test match.mate[1] == 4
        @test match.mate[4] == 1
        @test match.mate[2] == 3
        @test match.mate[3] == 2

        g = complete_bipartite_graph(4, 2)
        w = zeros(6, 6)
        w[3, 5] = 10
        w[3, 6] = 0.5
        w[2, 5] = 11
        w[1, 6] = 1
        w[1, 5] = -1

        match = maximum_weight_maximal_matching(
            g,
            w,
            algorithm = LPAlgorithm(),
            optimizer = HiGHS.Optimizer,
            cutoff = 0,
        )
        @test match.weight ≈ 12
        @test match.mate[1] == 6
        @test match.mate[2] == 5
        @test match.mate[3] == -1
        @test match.mate[4] == -1
        @test match.mate[5] == 2
        @test match.mate[6] == 1


        g = complete_bipartite_graph(2, 2)
        w = zeros(4, 4)
        w[1, 3] = 10.0
        w[1, 4] = 1.0
        w[2, 3] = 2.0
        w[2, 4] = 11.0
        match = maximum_weight_maximal_matching(g, w, algorithm = HungarianAlgorithm())
        @test match.weight ≈ 21
        @test match.mate[1] == 3
        @test match.mate[3] == 1
        @test match.mate[2] == 4
        @test match.mate[4] == 2

        g = complete_graph(3)
        w = zeros(3, 3)
        @test !is_bipartite(g)
        @test_throws ErrorException maximum_weight_maximal_matching(
            g,
            w,
            algorithm = HungarianAlgorithm(),
        )

        g = complete_bipartite_graph(2, 4)
        w = zeros(6, 6)
        w[1, 3] = 10
        w[1, 4] = 0.5
        w[2, 3] = 11
        w[2, 4] = 1
        match = maximum_weight_maximal_matching(g, w, algorithm = HungarianAlgorithm())
        @test match.weight ≈ 11.5

        g = Graph(4)
        add_edge!(g, 1, 3)
        add_edge!(g, 1, 4)
        add_edge!(g, 2, 4)
        w = zeros(4, 4)
        w[1, 3] = 1
        w[1, 4] = 3
        w[2, 4] = 1
        match = maximum_weight_maximal_matching(g, w, algorithm = HungarianAlgorithm())
        @test match.weight ≈ 2

    end



    @testset "minimum_weight_perfect_matching" begin
        algos = Any[LEMONMWPMAlgorithm()]
        if !Sys.iswindows() && Sys.ARCH == :x86_64
            push!(algos, BlossomVAlgorithm())
        end
        for algorithm in algos

        w = Dict(Edge(1, 2) => 500)
        g = Graph(2)
        add_edge!(g, 1, 2)
        match = minimum_weight_perfect_matching(g, w, algorithm)
        @test match.mate[1] == 2


        w = Dict(
            Edge(1, 2) => 500,
            Edge(1, 3) => 600,
            Edge(2, 3) => 700,
            Edge(3, 4) => 100,
            Edge(2, 4) => 1000,
        )

        g = complete_graph(4)
        match = minimum_weight_perfect_matching(g, w, algorithm)
        @test match.mate[1] == 2
        @test match.mate[2] == 1
        @test match.mate[3] == 4
        @test match.mate[4] == 3
        @test match.weight ≈ 600

        w = Dict(
            Edge(1, 2) => 500,
            Edge(1, 3) => 400,
            Edge(2, 3) => 300,
            Edge(3, 4) => 1000,
            Edge(2, 4) => 1000,
        )
        g = complete_graph(4)
        match = minimum_weight_perfect_matching(g, w, algorithm)
        @test match.mate[1] == 3
        @test match.mate[2] == 4
        @test match.mate[3] == 1
        @test match.mate[4] == 2
        @test match.weight ≈ 1400

        g = complete_bipartite_graph(2, 2)
        w = Dict{Edge,Float64}()
        w[Edge(1, 3)] = -10
        w[Edge(1, 4)] = -0.5
        w[Edge(2, 3)] = -11
        w[Edge(2, 4)] = -1

        match = minimum_weight_perfect_matching(g, w, algorithm)
        @test match.mate[1] == 4
        @test match.mate[4] == 1
        @test match.mate[2] == 3
        @test match.mate[3] == 2
        @test match.weight ≈ -11.5


        g = complete_graph(4)
        w = Dict{Edge,Float64}()
        w[Edge(1, 3)] = 10
        w[Edge(1, 4)] = 0.5
        w[Edge(2, 3)] = 11
        w[Edge(2, 4)] = 2
        w[Edge(1, 2)] = 100

        match = minimum_weight_perfect_matching(g, w, 50, algorithm)
        @test match.mate[1] == 4
        @test match.mate[4] == 1
        @test match.mate[2] == 3
        @test match.mate[3] == 2
        @test match.weight ≈ 11.5

        # Issue #5
        g = Graph(Graph([Edge(1, 2), Edge(2, 3), Edge(4, 1)]))
        w = Dict(Edge(1, 2) => 2.0, Edge(2, 3) => 2.0, Edge(1, 4) => 2.0)
        match = minimum_weight_perfect_matching(g, w)
        @test match.mate == [4, 3, 2, 1]
        @test match.weight == 4.0

        g = Graph([Edge(1, 2)])
        wFloat = Dict(Edge(1, 2) => 2.0)
        wInt = Dict(Edge(1, 2) => 2)
        matchFloat = minimum_weight_perfect_matching(g, wFloat, algorithm)
        matchInt = minimum_weight_perfect_matching(g, wInt, algorithm)
        @test matchFloat.mate == matchInt.mate
        @test matchFloat.weight == matchInt.weight

        end
    end
end

"""
    minimum_weight_perfect_matching(g, w::Dict{Edge,Real})
    minimum_weight_perfect_matching(g, w::Dict{Edge,Real}, cutoff)

Given a graph `g` and an edgemap `w` containing weights associated to edges,
returns a matching with the mimimum total weight among the ones containing
exactly `nv(g)/2` edges.

Edges in `g` not present in `w` will not be considered for the matching.

This function relies on the BlossomV.jl package, a julia wrapper
around Kolmogorov's BlossomV algorithm.

Eventually a `cutoff` argument can be given, to the reduce computational time
excluding edges with weights higher than the cutoff.

The returned object is of type `MatchingResult`.

In case of error try to change the optional argument `tmaxscale` (default is `tmaxscale=10`).
"""
function minimum_weight_perfect_matching end

function minimum_weight_perfect_matching(g::Graph, w::Dict{E,U}, cutoff, kws...) where {U<:Real, E<:Edge}
    wnew = Dict{E, U}()
    for (e, c) in w
        if c <= cutoff
            wnew[e] = c
        end
    end
    return minimum_weight_perfect_matching(g, wnew; kws...)
end

function minimum_weight_perfect_matching(g::Graph, w::Dict{E,U}; tmaxscale=10.) where {U<:AbstractFloat, E<:Edge}
    wnew = Dict{E, Int32}()
    cmax = maximum(values(w))
    cmin = minimum(values(w))
    tmax = typemax(Int32)  / tmaxscale # /10 is kinda arbitrary,
                                # hopefully high enough to not occur in overflow problems
    for (e, c) in w
        wnew[e] = round(Int32, (c-cmin) / (cmax-cmin) * tmax)
    end
    match = minimum_weight_perfect_matching(g, wnew)
    weight = zero(U)
    for i=1:nv(g)
        j = match.mate[i]
        if j > i
            weight += w[E(i,j)]
        end
    end
    return MatchingResult(weight, match.mate)
end

function minimum_weight_perfect_matching(g::Graph, w::Dict{E,U}) where {U<:Integer, E<:Edge}
    m = BlossomV.Matching(nv(g))
    for (e, c) in w
        BlossomV.add_edge(m, src(e)-1, dst(e)-1, c)
    end
    BlossomV.solve(m)

    mate = fill(-1, nv(g))
    totweight = zero(U)
    for i=1:nv(g)
        j = BlossomV.get_match(m, i-1) + 1
        mate[i] = j <= 0 ? -1 : j
        if i < j
            totweight += w[Edge(i,j)]
        end
    end
    return MatchingResult(totweight, mate)
end

using Documenter
using GraphsMatching
import Graphs

makedocs(
    modules = [GraphsMatching],
    format = :html,
    sitename = "GraphsMatching",
	pages = Any[
		"Getting started"         => "index.md",
    ]
)

deploydocs(
    deps        = nothing,
    make        = nothing,
    repo        = "github.com/JuliaGraphs/GraphsMatching.jl.git",
    target      = "build",
    julia       = "0.6",
    osname      = "linux"
)

function maximum_weight_maximal_matching_lp(g::Graph, optimizer, w::AbstractMatrix{T}, cutoff::R) where {T<:Real, R<:Real}
    return maximum_weight_maximal_matching_lp(g, optimizer, cutoff_weights(w, cutoff))
end

function maximum_weight_maximal_matching_lp(g::Graph, optimizer, w::AbstractMatrix{T}) where {T<:Real}
# TODO support for graphs with zero degree nodes
# TODO apply separately on each connected component
    bpmap = bipartite_map(g)
    length(bpmap) != nv(g) && error("Graph is not bipartite")
    v1 = findall(isequal(1), bpmap)
    v2 = findall(isequal(2), bpmap)
    if length(v1) > length(v2)
        v1, v2 = v2, v1
    end

    nedg = 0
    edgemap = Dict{Edge,Int}()

    for j in 1:size(w,2)
        for i in 1:size(w,1)
            if w[i,j] > 0.0
                nedg += 1
                edgemap[Edge(i,j)] = nedg
                edgemap[Edge(j,i)] = nedg
            end
        end
    end

    model = Model(optimizer)
    @variable(model, x[1:length(w)] >= 0)

    for i in v1
        idx = Vector{Int}()
        for j in neighbors(g, i)
            if haskey(edgemap, Edge(i,j))
                push!(idx, edgemap[Edge(i,j)])
            end
        end
        if length(idx) > 0
            @constraint(model, sum(x[id] for id = idx) == 1)
        end
    end

    for j in v2
        idx = Vector{Int}()
        for i in neighbors(g, j)
            if haskey(edgemap, Edge(i,j))
                push!(idx, edgemap[Edge(i,j)])
            end
        end

        if length(idx) > 0
            @constraint(model, sum(x[id] for id = idx) <= 1)
        end
    end

    @objective(model, Max, sum(w[src(e),dst(e)] * x[edgemap[e]] for e in keys(edgemap)))

    optimize!(model)
    status = JuMP.termination_status(model)
    status != MOI.OPTIMAL  && error("JuMP solver failed to find optimal solution.")
    sol = JuMP.value.(x)

    all(Bool[s == 1 || s == 0 for s in sol]) || error("Found non-integer solution.")

    cost = JuMP.objective_value(model)

    mate = fill(-1, nv(g))
    for e in edges(g)
        if w[src(e),dst(e)] > zero(T)
            inmatch = convert(Bool, sol[edgemap[e]])
            if inmatch
                mate[src(e)] = dst(e)
                mate[dst(e)] = src(e)
            end
        end
    end

    return MatchingResult(cost, mate)
end

 # GraphsMatching.jl: matching algorithms for Graphs.jl

```@meta
CurrentModule = GraphsMatching
DocTestSetup = quote
    using GraphsMatching
    import Graphs
end
```

This is the documentation page for `GraphsMatching`.
In all documentation examples, we assume GraphsMatching has been imported into scope
and that Graphs.jl is imported:
```julia
using GraphsMatching
import Graphs
```

```@autodocs
Modules = [GraphsMatching]
Pages = ["GraphsMatching.jl", "maximum_weight_matching.jl", "lp.jl", "blossomv.jl"]
Order = [:function, :type]
```
